<!----------------------------------------------------------------------------------------------------------------------
  -- colorModeDropdown
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="color-mode">
        <BDropdown class="me-2" right>
            <template #button-content>
                <Fa :icon="colorModes[currentMode].icon" />
            </template>
            <BDropdownItem @click="setMode('auto')">
                <Fa :icon="colorModes.auto.icon" />
                {{ colorModes.auto.display }}
            </BDropdownItem>
            <BDropdownItem @click="setMode('dark')">
                <Fa :icon="colorModes.dark.icon" />
                {{ colorModes.dark.display }}
            </BDropdownItem>
            <BDropdownItem @click="setMode('light')">
                <Fa :icon="colorModes.light.icon" />
                {{ colorModes.light.display }}
            </BDropdownItem>
        </BDropdown>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { useObservable } from '../../lib/composables/rxjs.js';

    // Resource Access
    import colorModeRA from '../../lib/resource-access/colorMode.js';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const colorModes = {
        auto: {
            display: 'Auto',
            icon: [ 'fas', 'circle-half-stroke' ],
        },
        dark: {
            display: 'Dark',
            icon: [ 'fas', 'moon' ],
        },
        light: {
            display: 'Light',
            icon: [ 'fas', 'sun' ],
        },
    };

    const currentMode = useObservable(colorModeRA.colorMode$);

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function setMode(mode : 'auto' | 'dark' | 'light') : void
    {
        colorModeRA.setColorMode(mode);
    }
</script>

<!--------------------------------------------------------------------------------------------------------------------->
